package com.example.lecteurdenouvelles.models;



import java.util.Vector;



import org.json.JSONArray;
import org.json.JSONObject;

/**
 * @author jub
 * L'ensemble des catgories obtenu a partir du flux JSON l'URL http://10.0.2.2/android/main/getCategories
 */
public class Categories extends JSONReader {
	/**
	 * L'ensemble des catgories
	 */
	private Vector<Categorie> categories;

	/**
	 * Permet de construie l'ensemble des catgorie en parsant les donnes du flux
	 */
	public Categories(){
		super("main/getCategories");
		this.categories = new Vector<Categorie>();
		this.parse();
	}


	@Override
	public void parse() {
		String read = read();

		try {
			JSONArray jsonArray = new JSONArray(read);
			/*Log.i(this.getClass().getName(),
					"Number of entries " + jsonArray.length());*/
			for (int i = 0; i < jsonArray.length(); i++) {
				JSONObject jsonObject = jsonArray.getJSONObject(i);
				//Log.i(this.getClass().getName(), jsonObject.getString("nom"));
				this.categories.add(new Categorie(jsonObject.getString("nom")));
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

	}


	/**
	 * Permet de connatre l'ensemble des catgories
	 * @return l'ensemble des catgories
	 */
	public Vector<Categorie> getCategories() {
		return categories;
	}


	


}
