package com.example.lecteurdenouvelles.models;

import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;

/**
 * @author jub
 * Une image est connue par son URL et sa description
 */
public class Image {

	/**
	 * L'URL de l'image
	 */
	private String url;
	/**
	 * La description de l'image
	 */
	private String description;
	/**
	 * Permet de construire une image  partir d'une URL relative et d'une description
	 * @param url l'URL relative
	 * @param description la description
	 */
	public Image(String url, String description) {
		super();
		this.url = url;
		this.description = description;
	}
	/**
	 * Permet d'obtenir la bitmap associe  l'URL. 
	 * @return la bitmap
	 */
	public Bitmap getBitmap(){
		Bitmap bitmap = null;

		
			try {
				
				HttpClient client = new DefaultHttpClient();
				//Avec l'emulateur les redirection http sont impossibles
				Site site  = new Site();
				HttpGet httpGet = new HttpGet(site.getUrl()+"/ressources/images/"+this.url);
				
			
				
				
				HttpResponse response = client.execute(httpGet);
				InputStream inputStream = response.getEntity().getContent();
				bitmap = BitmapFactory.decodeStream(inputStream);
			} catch (MalformedURLException e) {
				
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return bitmap;


	}
	/**
	 * Permet de connatre la description de l'URL
	 * @return la description
	 */
	public String getDescription() {
		return description;
	}
	/**
	 * Permet de connatre l'URL
	 * @return l'URL
	 */
	public String getUrl() {
		return url;
	}

	
	@Override
	public String toString() {
		return "Image [url=" + url + ", description=" + description + "]";
	}
	

}
