package com.example.lecteurdenouvelles.models;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;


import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;

import org.apache.http.impl.client.DefaultHttpClient;


import android.util.Log;

/**
 * @author jub
 * La classe abstraite qui nous permet de lire un flux JSON, elle est caractrise par l'URL du flux.
 */
public abstract class JSONReader {
	/**
	 * l'URL du flux
	 */
	private String url;
	
	/**
	 * Permet de construire un JSON reader  partir d'une URL
	 * @param url l'URL
	 */
	public JSONReader(String url){
		Site site = new Site();
		this.url = site.getUrl()+url;
	}
	
	/**
	 * Mthode abstraite qui permet de parser le flux
	 */
	public abstract void parse();
	//source de vogella
	/**
	 * Permet d'obtenir une chane de caractres JSON associe  l'URL 
	 * @return la chane de caractres JSON associe  l'URL 
	 */
	protected String read() {
		StringBuilder builder = new StringBuilder();
	/*	HttpClient client = new DefaultHttpClient();
		//HttpParams params = client.getParams(); 
		//HttpClientParams.setRedirecting(params, false); 
		HttpGet httpGet = new HttpGet(this.url);
		try {
			HttpResponse response = client.execute(httpGet);
			StatusLine statusLine = response.getStatusLine();
			int statusCode = statusLine.getStatusCode();
			if (statusCode == 200) {
				HttpEntity entity = response.getEntity();
				InputStream content = entity.getContent();
				BufferedReader reader = new BufferedReader(
						new InputStreamReader(content));
				String line;
				while ((line = reader.readLine()) != null) {
					builder.append(line);
				}
			} else {
				
				Log.e(this.getClass().getName().toString(), "Failed to download file");
			}
		} catch (ClientProtocolException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return builder.toString();*/
		try {
			HttpURLConnection client = (HttpURLConnection) new URL(this.url).openConnection();
			InputStream inputStream = new BufferedInputStream(client.getInputStream());
			BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream));
			
			String line;
			while ((line = reader.readLine()) != null) {
				builder.append(line);
			}
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return builder.toString();
	}
}
