package com.example.lecteurdenouvelles.models;

import java.util.Vector;

import org.json.JSONArray;
import org.json.JSONObject;



/**
 * @author jub
 *L'ensemble de toutes les nouvelles obtenues  partir du nom d'une catgorie.
 */
public class Nouvelles extends JSONReader {

	/**
	 * Les nouvelles
	 */
	private Vector<Nouvelle> nouvelles;
	
	/**
	 * Permet de construire les nouvelle  partir du flux JSON http://10.0.2.2/android/main/getNouvellesByCategorie/nomCategorie
	 * @param nomCategorie le nom de la catgorie
	 */
	public Nouvelles(String nomCategorie) {
		super("main/getNouvellesByCategorie/"+nomCategorie);
		this.nouvelles = new Vector<Nouvelle>();
		parse();
	}

	/**
	 * Permet de connatre l'ensemble des nouvelles
	 * @return l'ensemble des nouvelles associe  la catgorie choisie
	 */
	public Vector<Nouvelle> getNouvelles() {
		return nouvelles;
	}

	@Override
	public void parse() {
		String read = read();

		try {
			JSONArray jsonArray = new JSONArray(read);
			for (int i = 0; i < jsonArray.length(); i++) {
				JSONObject jsonObject = jsonArray.getJSONObject(i);
				int idnouvelle = jsonObject.getInt("idnouvelle");
				Nouvelle nouvelle = new Nouvelle(idnouvelle);
				this.nouvelles.add(nouvelle);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	

	@Override
	public String toString() {
		return "Nouvelles [nouvelles=" + nouvelles + "]";
	}
	
	

}
